# A description of what this class does
#
# @summary A short summary of the purpose of this class
#
# @example
#   include workstation::asdf
class workstation::asdf (
  Boolean $manage = true,
  String[1] $user = $workstation::user,
  String[1] $home = $workstation::home,
  Integer $timeout = 300,
  Optional[Hash[String[1], Array[String[1]]]] $packages = undef,
  Optional[Hash[String[1], String[1]]] $globals = undef,
) {

  if $manage {
    class { 'workstation::asdf::manage':
      before => Class['workstation::asdf::packages'],
    }
  }

  include workstation::asdf::packages

  $globals_erb = "<% @globals.each do |key, val| -%>
<%= key %> <%= val %>
<% end %>
"

  if $globals {
    file { "${home}/.tool-versions":
      content => inline_template($globals_erb),
      owner   => $user,
    }
  } else {
    notice('No asdf globals provided.')
  }

}
