# A description of what this class does
#
# @summary A short summary of the purpose of this class
#
# @example
#   include workstation::files
class workstation::dotfiles (
  String[1] $user = $workstation::user,
  String[1] $home = $workstation::home,
  Optional[Array[Hash]] $files = $workstation::dotfiles,
) {

  if $files {
    $files.each |$file| {
      if has_key($file, 'parents') {
        $file['parents'].each |$parent| {
          file { "${home}/${parent}":
            ensure => directory,
            owner  => $user,
            before => File["${home}/${file['file']}"],
          }
        }
      }

      $content = $file['format'] ? {
        'json'       => to_json($file['data']),
        'prettyjson' => to_json_pretty($file['data']),
        'yaml'       => to_yaml($file['data']),
      }

      file { "${home}/${file['file']}":
        ensure  => present,
        owner   => $user,
        content => $content,
      }
    }
  }

}
