# @summary
#  This class installs Homebrew taps, casks and formulae
#
# @api private
#
class workstation::mac::homebrew::packages (
  Optional[Hash[String[1], Array[String[1]]]] $packages = $workstation::mac::homebrew::packages,
) {

  if $packages {
    if has_key($packages, 'taps') {
      $taps = $packages['taps']
      $taps.each |String $tap| {
        package { $tap:
          ensure   => present,
          provider => 'tap',
        }
      }
    } else {
      $taps = undef
    }

    if has_key($packages, 'formulae') {
      $packages['formulae'].each |String $formula| {
        package { $formula:
          ensure   => present,
          name     => $formula,
          provider => 'brew',
        }
      }
    }

    if has_key($packages, 'casks') {
      $packages['casks'].each |String $cask| {
        package { "cask_${cask}":
          ensure   => present,
          name     => $cask,
          provider => 'brewcask',
          require  => Package[$taps],
        }
      }
    }
  }

}
